#!/usr/bin/python

import sys

def error(x):
	sys.stderr.write(x)

if len(sys.argv) < 4:
	error('usage ' + sys.argv[0] + ' [-s] readfile outfile splitsize [overlap size]\n')
	sys.exit(1)

if sys.argv[1] == '-s':
	mod = 1
	useSam = True
else:
	mod = 0
	useSam = False
if sys.argv[2 + mod] == '-':
	outfile = sys.stdout
else:
	outfile = open(sys.argv[2 + mod],'w')
if sys.argv[1 + mod] == '-':
	readfile = sys.stdin
else:
	readfile = open(sys.argv[1 + mod],'r')
def out(x):
	outfile.write(x)
splitsize = int(sys.argv[3 + mod])
if len(sys.argv) > 4 + mod:
	overlapsize = int(sys.argv[4 + mod])
else:
	overlapsize = 100

last = ''
laststart = 0
lastend = 0
prevstart = 0
prevend = 0
swap = False

for line in readfile:
	if useSam:
		if line[0] == '@':
			out(line)
		else:
			s = line.split('\t')
			s[0] = s[0].replace(' ','_')
			contigname = s[2]
			contigstart = int(s[3])
			contigstartnum = contigstart / splitsize
			contigstartpos = contigstart % splitsize
			
			if contigstartpos > splitsize - (overlapsize / 2):
				s[2] = contigname + '_' + str(contigstartnum + 1)
				start = contigstartpos - ( splitsize - (overlapsize / 2))
				s[3] = str(start)
			
				out('\t'.join(s))
			
			s[2] = contigname + '_' + str(contigstartnum)
			start = contigstartpos
			if contigstartnum != 0:
				start += overlapsize / 2
			s[3] = str(start)
			out('\t'.join(s))
			
	else:
		if line[0] == '>':
			if(last):
				out(last)
				last = ''
			s=line.split('\t')
			s[0] = s[0].replace(' ','_')
			contigstart = int(s[3])
			contigend = int(s[4])
			swap = s[2] == '-'
			diff = contigend - contigstart
			
			if not diff < overlapsize / 2:
				print 'too small overlap size'
				print diff, overlapsize
				print line
				exit(1)
			
			contigname = s[1]
		
			contigstartnum = contigstart / splitsize
			contigendnum = contigend / splitsize
			contigstartpos = contigstart % splitsize
			contigendpos = contigend % splitsize
		
			if contigstartpos > splitsize - (overlapsize / 2):
				s[1] = contigname + '_' + str(contigstartnum + 1)
				start = contigstartpos - ( splitsize - (overlapsize / 2))
				s[3] = str(start)
				s[4] = str(start + diff)
				laststart = start
				lastend = start + diff
				last = '\t'.join(s)
		
			s[1] = contigname + '_' + str(contigstartnum)
			start = contigstartpos
			if contigstartnum != 0:
				start += overlapsize / 2
			s[3] = str(start)
			s[4] = str(start + diff)
			prevstart = start
			prevend = start + diff
		
			out('\t'.join(s))
		
		elif line[0] == 'G':
			digits = 0
			writestart = True
			for c in line:
				if ord('0') <= ord(c) <= ord('9'):
					digits += 1
				else:
					if digits:
						if writestart != swap:
							writestart = False
							if last:
								last += str(laststart).rjust(digits)
							out(str(prevstart).rjust(digits))
						else:
							if last:
								last += str(lastend).ljust(digits)
							out(str(prevend).ljust(digits))
							writestart = False
						
						digits = 0
					out(c)
					if last:
						last += c
		else:
			out(line)
			if last:
				last += line
